/* integer.c   by Michael Thorpe   2005-08-13 */

#include <stdio.h>
#include "lisp.h"

static obj *integer_tostring(obj *in) {
	obj *out;
	char buf[22];
	int i;

	i=snprintf(buf,sizeof(buf),"%ld",in->value.i);
	if(i==-1 || i>sizeof(buf))
		return(throwrangecheck(in));
	decref(in);
	out=real_new_string(buf,i);
	return(out);
}

objtype integer_objtype={
	name: "integer",
	tostring: integer_tostring
};

obj trueobj={&integer_objtype,{refcount:1},{i:1}};

